#include <Keyboard.h>

// 定義LED和按鈕的引腳
const int ledD6 = 6;
const int ledD8 = 8;
const int btnD7 = 7;
const int btnD9 = 9;

// 用來追蹤LED的狀態
bool ledD6State = LOW;
bool ledD8State = LOW;

void setup() {
  pinMode(ledD6, OUTPUT);
  pinMode(ledD8, OUTPUT);
  pinMode(btnD7, INPUT_PULLUP);
  pinMode(btnD9, INPUT_PULLUP);

  // 初始化Arduino鍵盤
  Keyboard.begin();
}

void loop() {
  // 隨機選擇D6或D8燈
  int selectedLED = random(2) == 0 ? ledD6 : ledD8;

  if (selectedLED == ledD6) {
    digitalWrite(ledD6, HIGH);
    unsigned long startTime = millis();
    ledD6State = HIGH;

    while (ledD6State == HIGH) {
      if (digitalRead(btnD7) == LOW) {
        unsigned long elapsedTime = millis() - startTime;
        ledD6State = LOW;
        digitalWrite(ledD6, LOW);

        if (elapsedTime <= 500) {
          Keyboard.press(KEY_RIGHT_ARROW);
          delay(100);
          Keyboard.release(KEY_RIGHT_ARROW);
        } else if (elapsedTime <= 2000) {
          Keyboard.press(KEY_DOWN_ARROW);
          delay(100);
          Keyboard.release(KEY_DOWN_ARROW);
        } else if (elapsedTime <= 3000) {
          Keyboard.press(KEY_LEFT_ARROW);
          delay(100);
          Keyboard.release(KEY_LEFT_ARROW);
        } else if (elapsedTime <= 4000) {
          Keyboard.press(KEY_UP_ARROW);
          delay(100);
          Keyboard.release(KEY_UP_ARROW);
        }
      }
    }

  } else if (selectedLED == ledD8) {
    digitalWrite(ledD8, HIGH);
    unsigned long startTime = millis();
    ledD8State = HIGH;

    while (ledD8State == HIGH) {
      if (digitalRead(btnD9) == LOW) {
        unsigned long elapsedTime = millis() - startTime;
        ledD8State = LOW;
        digitalWrite(ledD8, LOW);

        if (elapsedTime <= 500) {
          Keyboard.press(KEY_RIGHT_ARROW);
          delay(100);
          Keyboard.release(KEY_RIGHT_ARROW);
        } else if (elapsedTime <= 1000) {
          Keyboard.press(KEY_DOWN_ARROW);
          delay(100);
          Keyboard.release(KEY_DOWN_ARROW);
        } else if (elapsedTime <= 1500) {
          Keyboard.press(KEY_LEFT_ARROW);
          delay(100);
          Keyboard.release(KEY_LEFT_ARROW);
        } else if (elapsedTime <= 2000) {
          Keyboard.press(KEY_UP_ARROW);
          delay(100);
          Keyboard.release(KEY_UP_ARROW);
        }
      }
    }
  }

  delay(4000);  // 等待2秒後再次隨機選擇
}
